package fr.upsaclay.bibs.fieldsystem.control;

/**
 * List of actions that sent from the view to the controller 
 * 
 * @author Viviane Pons
 *
 */
public enum FieldAction {
	INITIAL_START("", null),
	PAUSE("", null),
	START("", null),
	QUIT("", null),
	EVOLVE("", null),
	INITIAL_SHEEPS("50", FieldParameterType.INT),
	INITIAL_WOLVES("50", FieldParameterType.INT)
	;
	
	private final String defaultValue;
	private final FieldParameterType type;
	
	FieldAction(String defaultValue, FieldParameterType type) {
		this.defaultValue = defaultValue;
		this.type = type;
	}
	
	public String getDefaultValue() {
		return defaultValue;
	}
	
	public FieldParameterType getType() {
		return type;
	}
	
	

}
