package fr.upsaclay.bibs.fieldsystem.control;


import fr.upsaclay.bibs.fieldsystem.sheepfield.Field;
import fr.upsaclay.bibs.fieldsystem.sheepfield.Grass;
import fr.upsaclay.bibs.fieldsystem.sheepfield.Sheep;
import fr.upsaclay.bibs.fieldsystem.sheepfield.Wolf;
import fr.upsaclay.bibs.fieldsystem.view.FieldView;
import fr.upsaclay.bibs.fieldsystem.view.SwingFieldView;
import fr.upsaclay.bibs.fieldsystem.view.ViewState;

/**
 * The controller of the application
 * 
 * @author viviane
 *
 */
public class FieldController  {
	
	public static final int WIDTH = 60;
	public static final int HEIGHT = 40;
	public static final int INITIAL_DELAY = 500;

	private Field field;
	private FieldView view;
	
	private int numberOfInitialSheeps = 50;
	private int numberOfInitialWolves = 50;

	
	public FieldController() {
		view = new SwingFieldView("Sheep field", WIDTH, HEIGHT);
	}
	
	public void initialize() {
		view.setController(this);
		view.initialize();
		view.setViewState(ViewState.SIMULATION_INIT);
	}

	public int getNumberOfIntialSheeps() {
		return numberOfInitialSheeps;
	}

	public void setNumberOfInitialSheeps(int numberOfInitialSheeps) {
		this.numberOfInitialSheeps = numberOfInitialSheeps;
	}

	public int getNumberOfInitialWolves() {
		return numberOfInitialWolves;
	}

	public void setNumberOfInitialWolves(int numberOfInitialWolves) {
		this.numberOfInitialWolves = numberOfInitialWolves;
	}

	/**
	 * Launches the simulation :
	 *  * create the field
	 *  * adds the sheep and wolves
	 *  * initiate the view
	 */
	private void initial_start() {
		/* Write your code here */
	}

	/**
	 * Quit the simulation
	 */
	private void quit() {
		/* Write your code here */
	}

	/**
	 * Launches the option management panel
	 */
	private void startManagement() {
		/* Write your code here */
	}

	/**
	 * Erase the management panel and goes back either to:
	 * - initial panel (if the simulation has not started)
	 * - pause panel otherwise
	 */
	private void stopManagement() {
		/* Write your code here */
	}


	/**
	 * Receives an action with no extra parameter
	 * @param action, the action to be performed
	 */
	public void receiveAction(FieldAction action) {
		switch (action) {
			case INITIAL_START: initial_start(); break;
		}
		view.update();
	}

	/**
	 * Receives an action with an extra string parameter
	 * The string must be a verified string which will be directly converted into the wanted parameter value
	 * @param action, the action to be performed
	 * @param v, the sent value
	 */
	public void receiveAction(FieldAction action, String v) {
		/* Write your code here */
	}
}
