package fr.upsaclay.bibs.fieldsystem.view;

import java.awt.*;
import java.util.ArrayList;
import java.util.List;

import javax.swing.*;

import fr.upsaclay.bibs.fieldsystem.control.FieldAction;
import fr.upsaclay.bibs.fieldsystem.control.FieldController;
import fr.upsaclay.bibs.fieldsystem.control.FieldParameterType;
import fr.upsaclay.bibs.fieldsystem.control.ParameterVerifier;
import fr.upsaclay.bibs.fieldsystem.sheepfield.Field;

/**
 * The implementation of FieldView with Swing JFrame
 * 
 * @author Viviane Pons
 *
 */
public class SwingFieldView extends JFrame implements FieldView {
	
	public static final int PIXELS_PER_CELLS = 20;

	private FieldController controller;
	
	
	DrawPanel drawPanel;
	JPanel controlPanel;
	Timer timer;
	
	JPanel initialPanel;

	

	public SwingFieldView(String name, int widthField, int heightField) {
		super(name);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setResizable(false);
		
		// Create the drawPanel (where we draw the field)
		drawPanel = new DrawPanel(widthField, heightField);
		
		// Create the control panel
		controlPanel = new JPanel();
		
		// Create the loop timer
		timer = new Timer(1, null);
	}

	/**
	 * Create a FieldParamater with an attached ParameterListener
	 * @param label, the label of the parameter
	 * @param action, the action to be sent to the controller
	 * @return the field parameter element to be added to the view
	 */
	private FieldParameter createParameter(String label, FieldAction action) {
		throw new UnsupportedOperationException("Not implemented");
	}
	

	@Override
	public void initialize() {
		// General initialization
		drawPanel.initialize();
		add( drawPanel, BorderLayout.CENTER );
		add( controlPanel, BorderLayout.EAST);
		controlPanel.setPreferredSize(new Dimension(300, drawPanel.getPreferredSize().height));
		
		// Initializing all management panels
		// The initial panel
		initialPanel = new JPanel();
		initialPanel.setPreferredSize(new Dimension(controlPanel.getPreferredSize().width, drawPanel.getPreferredSize().height));
		JButton initialStartButton;
		initialStartButton = new JButton("Start");
		initialPanel.add(initialStartButton);

		// Add the initial parameters to the list

		controlPanel.add(initialPanel);

		// Timer initialization
		/* Write your code here */
		
		// The play panel (when the simulation is running)
		/* Write your code here */
		
		// The pause panel (when the game is on pause)
		// Write your code here
		pack();
		setVisible(true);
	}

	@Override
	public void update() {
		repaint();
	}

	@Override
	public void setLoopDelay(int ms) {
		/* Write your code here */
	}

	private void drawSimulationInitView() {
		initialPanel.setVisible(true);

	}


	@Override
	public void setViewState(ViewState state) {
		switch (state) {
			case SIMULATION_INIT: drawSimulationInitView();break;
		}
	}
	@Override
	public void setField(Field field) {
		drawPanel.setField(field);
	}

	@Override
	public void setController(FieldController controller) {
		this.controller = controller;
	}

}
